import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';
import { AlertModel } from '../model/alert.model';
import { AppraisalFormModel } from '../model/appraisal-form.model';
import { AppraisalCompentencyModel, AppraisalCompentencyModel2 } from '../model/appraisal-competency.model';
import { AppraisalSubordinateModel } from '../model/appraisal-subordinate.model';
@Injectable({
  providedIn: 'root'
})
export class AppraisalService {
  api = "/appraisal"
  urlApi = environment.baseUrl + this.api
  constructor(private http: HttpClient) {
  }
  getFormCompentencyById(evaluationRoundId: string, apsassessy: string, typeId: string): Observable<AppraisalCompentencyModel2> {
    return this.http.get<AppraisalCompentencyModel2>(this.urlApi + "/competency/" + evaluationRoundId + "/" + apsassessy + "/" + typeId)
  }
  getCompetencyList(employeeId?: string): Observable<AppraisalCompentencyModel[]> {
    return this.http.get<AppraisalCompentencyModel[]>(this.urlApi + "/competency/emp" + (employeeId ? "?employeeid=" + employeeId : ''))
  }
  postCompetency(body: AppraisalCompentencyModel2): Observable<AlertModel> {
    return this.http.post<AlertModel>(this.urlApi + "/competency", body)
  }
  getBossList(): Observable<AppraisalSubordinateModel[]> {
    return this.http.get<AppraisalSubordinateModel[]>(this.urlApi + "/boss/emp")
  }
}